/*                                                                 */
/* Aut(F_n) computation                                            */
/*                                                                 */
/* Ferenc Gerlits, PhD dissertation, Cornell University, Aug 2002  */
/*                                                                 */
/* Select graphs of rank n and less from the list of degree k graphs. */

package Homology;

import java.util.Vector;
import java.io.*;

public class SelectRank
{
  private final static int[] count = { 0, 0, 1, 2, 5, 9, 26, 59, 197, 547 }; 
											// number of graphs in each degree	
  public static void main(String argv[]) throws IOException,
                                                ClassNotFoundException {
    int deg, rank, i, j, num;
    Graph g;
    Tree tree;

    if (argv.length == 2) {
      deg = Float.valueOf(argv[0]).intValue();
      rank = Float.valueOf(argv[1]).intValue();
      }
    else {
      System.out.println("Usage: Homology.SelectRank degree rank");
      System.exit(1);
      deg = rank = 0;
      }

    FileInputStream infs = new FileInputStream("nbag" + deg + ".out");             
    ObjectInputStream ins = new ObjectInputStream(infs);
    FileOutputStream outfs = new FileOutputStream("nbag" + deg +"_" + 
           rank + ".out", false);             
    ObjectOutputStream outs = new ObjectOutputStream(outfs);
    
    num = 0;
    for (i=0; i<count[deg]; i++) {   
      g = (Graph)ins.readObject();
      if (g.valency <= 2*rank - deg) {
        outs.writeObject(g);
        num++;
        }
      }

    ins.close(); infs.close();
    outs.close(); outfs.close();
    System.out.println(num +" graphs out of "+ count[deg]);
    }
}
