/*                                                                 */
/* Aut(F_n) computation                                            */
/*                                                                 */
/* Ferenc Gerlits, PhD dissertation, Cornell University, Aug 2002  */
/*                                                                 */
/* WritePS.java                                                    */
/* Produces a postscript file from a Graph list.	           */

package Homology;

import java.util.Vector;
import java.io.*;

public class WritePS
{
  public static void main(String argv[]) throws IOException,
                                                ClassNotFoundException {
    int n, i,j;
    Graph g;
    Vector bag = new Vector(10,10);
    FileInputStream fs = null;
    ObjectInputStream s = null;
        
    fs = new FileInputStream(argv[0]);             
    s = new ObjectInputStream(fs);

    System.out.println("%!PS");
    System.out.println("(drawgraphs.ps) run");
    System.out.println();                // include header file
    System.out.println("[");
    System.out.println();

    n = 0;
    while (true) {
    try {
      g = (Graph)s.readObject();
      System.out.println("[");
      for (i=0; i<g.size; i++) {
        System.out.print("[");
        for (j=0; j<i; j++)
          System.out.print("\t");
        for (j=i; j<g.size; j++) { 
          System.out.print("\t" + g.m[i][j]);
          }
        System.out.println("\t]");
        }
      System.out.println("]");
      System.out.println("% "+g.size+","+g.symBag.size()+","+
                                                g.treeBag.size());
      System.out.println("% "+g.valency+","+g.neighbors+","+
                                                g.noEdges);
      System.out.println();
      }
    catch(EOFException e) {
      break;
      }
    }
     
    s.close();
    fs.close();

    System.out.println("] drawgraphs showpage");
    }
}
